//EncodePicFlash.h
// rein, September 2008
// update Oct 2011
#include "datatypes.h"  
#include "InOutPic.h"
#include "HelpFct.h"

void CompressPicFlash(INT16 *matrix, INT8 qmin,char* filenameout); /*
			   takes a wavelet transformed picture that is in the stack 
			   and codes it using a backward, recursive zerotree 
			   algorithm that uses extremely little memory

			   */
void   Code2Lines(INT16 *matrix,INT8 *MqlBuffer,INT16* LineBuffer,char *subband,INT8 level,UINT8 k,INT8 qmin);//k is the line index within the subband and starts from 0
//void Recode2Lines(INT16 *matrix,INT8 *MqlBuffer,INT16* LineBuffer,char *subband,INT8 level,UINT8 k,INT8 qminPrv,INT8 qmin);


void CodeLastLevels(INT16 *matrix,INT16 *LineBuffer,INT8 *qG123,INT8 qmin,INT8 qmax);//
// encodes the last 2 levels

void Read2Lines(INT16 *matrix,INT16 *buffer,char *subband,INT8 level,UINT8 k);
//k - line index: reads line k and line (k+1)

UINT16 GiveSet(UINT8 DimMql,UINT8 set);//returns the 4 LineBuffer indices for a given set

INT8 GiveMqlSet(INT16 *LineBuffer,UINT8 DimMql,UINT8 set);
INT8 GiveMqlSetQminPrv(INT16 *LineBuffer,UINT8 DimMql,UINT8 set,INT8 qminPrv);

INT8 Givelevel(INT16 *LineBuffer,UINT16 m);

void CodePixelFlash(INT16 pixel,INT8 qmin,INT8 qmax);

void CodeLevel(INT8 level,INT8 LowerBound,INT8 UpperBound);
UINT16 GiveChilds(UINT16 m,UINT16 MaxCols);

INT8 Max(INT8,INT8);



