//coder.h
//some common functions needed by EncodePic.c and DecodePic.c

#ifndef coder_H
#define coder_H
#include "datatypes.h" 
/*
struct list_{
  UINT16 m;   // position (i,j) of a node
  INT8 level;// maximum quantization level
  struct list_ *next;
};
typedef struct list_ list;

INT8 GiveMQD(list* map,UINT16 m);// give the mqd level of a node at pos m
list* AddMQD(list* map,UINT16 m,INT8 level);//just adds a given MQD node to the list
list* DeleteMQD(list* map,UINT16 m);

UINT16 GiveM(UINT16 i,UINT16 j,UINT16 MaxCols);//m starts from 0
void GiveIJ(UINT16 *i,UINT16 *j,UINT16 m,UINT16 MaxCols);
void PrintMQD(list*);//prints all MQD nodes in the list on screen
*/

//INT8 Log2(INT8 x);
//UINT8 Pow(UINT8 a,UINT8 b); 

void rescale(INT16 *matrix,UINT8 LastWaveletLevel,UINT8 ExpLastLevel,\
	     UINT8 undo);
/*The fct rescale scales the picture matrix back to integer values (with an
  exponent of 0); this makes sense as the coding algorithm only takes 
  integer values as an input; as a parameter the maximum wavelet level 
  and the exponent has to be given; the function can also undo the 
  operation if "undo" is set to 1; furthermore, a rounding is performed 
  through the function;
*/
//rescale a matrix after a "LastWaveletLevel" fixed-point wavelet transform;
//for instance, if it is a 5-level transform with "ExpLastLevel"=1, then:
//level | exp
//-----------
//  1   |  5
//  2   |  4
//  3   |  3
//  4   |  2
//  5   |  1
//remember that the exponent gives the real wavelet coefficient C by
//C=c*2^-exp(c),
//where c is the integer value of the internal binary word


void quantize(INT16 *matrix,INT8 qmin);
#endif
