// HelpFct.c
#include "HelpFct.h"

int Log2(UINT16 x){
  UINT8 r = 0;
  while( (x >> r) != 0){
    r++;
  }
  return r-1; // returns -1 for x==0, floor(log2(x)) otherwise
}
int Pow(int base, int exp){
  int result = 1;
  while (exp){
    if (exp & 1)
      result *= base;
    exp >>= 1;
    base *= base;
  }
  return result;
}

void PutMql(INT8 *buffer,UINT16 DimPic,INT8 level,UINT8 m,INT8 MqlLevel){
  //m is given as 0,1,2,3,..,DimSub/2-1
  UINT8 start=0;
  INT8 i;
  for (i=1;i<level;i++) start+=DimPic/Pow(2,i+1);
  buffer[start+m]=MqlLevel;
}

INT8 GetMql(INT8 *buffer,UINT16 DimPic,INT8 level,UINT8 m) {
  //m is given as 0,1,2,3,..,DimSub/2-1
  UINT8 start=0;
  INT8 i;
  for (i=1;i<level;i++) start+=DimPic/Pow(2,i+1);
  return buffer[start+m];
}


UINT16 GiveM(UINT16 i,UINT16 j,UINT16 MaxCols) {return i*MaxCols+j;}
void GiveIJ(UINT16 *i,UINT16 *j,UINT16 m,UINT16 MaxCols){//i and j both start from 0
  *i=m/MaxCols;
  *j=m-(*i)*MaxCols;     
}

INT8 GiveLevel(INT16 pixel){
  if (abs(pixel)>=1) return (INT8) Log2(  abs(pixel)  );
  else return -1;
}
